IModel = IRequest.subClass();

IModel.create = function(){
	
	var obj = this.prototype;
	
	obj.init = function(){
		this._names = [];
		this._elements = [];
		this._xpath = "//imodel/";
		this._XML = "";
	}
	
	obj.setAction = function (url) {
		this._action = url;
	};
	
	obj.getAction = function () {
		return this._action;
	};
	
	obj.getNames = function (){
		return this._names;
	}
	
	obj.getXpath = function (){
		return "imodel/";
	}
	
	obj.setXpath = function (xpath){
		this._xpath = xpath;
	}
	
	obj.setNames = function (names){
		this._names = names;
	}
	
	obj.getNodeText = function (node){
//		ILog.debug("node type is : " + node);
		if(node)
			return node.nodeType == 2 ? node.nodeValue : (node.firstChild ? node.firstChild.nodeValue : "");
		else
			return "";
	}
	
	obj.getProperty = function (name){
		if(this._XML){
//			ILog.debug(obj._xpath + name, "IModel.js");
			return this.getNodeText(this._XML.selectNodes(this._xpath + name)[0]);
		}
		return null;
	}
	
	obj.pull = function (){
		this.response();
	}
	
	obj.getElement = function (name){
		if(document.getElementById(name)){
			var element = new IElement();
			element.setElement(name);
		}
		return element;
	}	
	
	obj.draw = function (){
		if(!(this._names + "")){
			for(var j = 0; j < this._XML.documentElement.childNodes.length; j ++){
				var name = this._XML.documentElement.childNodes[j].nodeName;
				if(name == "#text")
					continue;
				this._names.push(name);
			}
		}
		if(this._names.length){
			for(var i = 0; i < this._names.length; i ++){
				var property = this.getProperty(this._names[i]);
				if(property && this.getElement(this._names[i]))
					this.getElement(this._names[i]).setText(property);
			}
		}
		return this._names;
	}
	
	obj.response = function (response) {
		var self = this;
		
		if(response){
			this._response = response;
		}
		if(this._isSend){
			this._http.onreadystatechange = function (){
				if(self._http.readyState == 4)
					if(self._http.status < 400){
						callbackHandler();
					}else{
						self._http.abort();
						ILog.error("abort because of wrang status");
					}
			}
		}else{
			return null;
		}
		
		function callbackHandler() {
			self._XML = self._http.responseXML;
			self.draw();
		}
	};
	
}

IModel.create();